#!/bin/bash

help()
{
  echo "Usage: $0 [OPTION]..."
  echo "Options: These are optional argument"
  echo " -i SUFF - add suffix SUFF for logfiles (result data and report) "
  echo " -s SIZE - use SIZE bytes for input buffer (2*SIZE for each input file)"
  echo " -S SIZE - use SIZE bytes for output buffer"
  exit 1
}

SUFFIX=""
ISIZE=0
OSIZE=0

while getopts i:s:S:h opt
do
  case "$opt" in
    i) SUFFIX="$OPTARG";;
    s) ISIZE="$OPTARG";;
    S) OSIZE="$OPTARG";;
    h) help;;
  esac
done


BIN="../src/for_merge"
if [ $ISIZE -ne 0 ]; then
    BIN="$BIN -s $ISIZE"
fi
if [ $OSIZE -ne 0 ]; then
    BIN="$BIN -S $OSIZE"
fi

IFORIG="../data/sorted_big_C.dat"
IF1="../data/sorted_big_C_part2.dat"
IF2="../data/sorted_big_C_part3.dat"
IF3="../data/sorted_big_C_part1.dat"

OF="sorted_big_result$SUFFIX.dat"
REPORT="sorted_big_result$SUFFIX.rep"


export LC_ALL=C
export LANG=en_US

#unlimit
#sudo sysctl -w vm.overcommit_memory="0"
#sudo sysctl -w vm.overcommit_ratio="50"

#/usr/bin/time -a -o $REPORT -f "TIME:\n%e\n%U\n%S\nMEM:\n%M\n%K\n%W\nIO:\n%I - %O\n" $BIN -o $OF -m $IF1 $IF2 > $REPORT 2>&1
/usr/bin/time -a -o $REPORT -- $BIN --output $OF $IF1 $IF2 $IF3 > $REPORT 2>&1

echo " " >> $REPORT
echo " " >> $REPORT

diff -q --speed-large-files $OF $IFORIG >> $REPORT 2>&1

exit 0
